C     INVARIANT CONFIDENCE INTERVALS FOR THE DIFFERENCE 
C                OF TWO SUCCESS PROBABILITIES
C
C                       program by
C                       Shin Yamagami
C                      Tokyo Gas Company  
C                          - 1990 -
C
C
      PROGRAM MAIN
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INTEGER X(NCLASS,2)
      DIMENSION ZDELTA(NCLASS,2)
      OPEN(UNIT=10,FILE='delta.inp')
      OPEN(UNIT=11,FILE='delta.out')
      READ(10,*) LN1,LN2
      READ(10,*) ALPHA
      READ(10,*) LPARTD, LPARTP
   15 FORMAT(/,' PART. OF DELTA = ',I6,2X,'PART. OF P1 = ',I6)
   16 FORMAT('ELAPSED TIME = ')  
   20 FORMAT('N1 = ',I2,5X,' N2 = ',I2,5X, 'ALPHA = ',F6.4)
   21 FORMAT(' X1 = ',I3,5X,' X2 = ',I3,5X,'DELTA_LO = ',F6.3,
     C5X,'DELTA_UP = ',F6.3)
      WRITE(11,15) LPARTD, LPARTP 
      CALL P1MP2(LN1,LN2,ALPHA,LPARTD,LPARTP,X,ZDELTA)
      N12=(LN1+1)*(LN2+1)
C     WRITE(11,16)
      WRITE(11,20) LN1,LN2,ALPHA
      DO 30 I = 1, N12
      WRITE(11,21) X(I,1),X(I,2),ZDELTA(I,1),ZDELTA(I,2)
   30 CONTINUE
      STOP
      END
C
C
      BLOCK DATA
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      END
C
C
      SUBROUTINE P1MP2(LN1,LN2,ZALPHA,LPARTD,LPARTP,X,ZDELTA)
C
C     MAIN SUBROUTINE
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'      
      DOUBLE PRECISION ZDELTA(NCLASS,2)
      INTEGER X(NCLASS,2)
c
      INCLUDE 'DELTA.H2'
C
C    SET THE PARAMETERS, CHECK WHICH IS LARGER,N1 OR N2?
C
      IF (LN1.LE.LN2) GOTO 30
      N1=LN2
      N2=LN1
      GOTO 20
 30   N1=LN1
      N2=LN2
 20   ALPHA=ZALPHA
      PARTD=LPARTD
      PARTP=LPARTP
C
C     INITIALIZING PROCEDURE FOR GLOBAL VARIABLES
C
      CALL SINIT
C
C     CALCULATE THE COMBINATORIAL AND OTHER COEFFICIENTS
C
      CALL COMBIN
C
C     CREATE THE INITIAL ACCEPTANCE REGION
C
      CALL CRZERO
C
C     RECURSIVELY CREATE NEW ACCEPTANCE REGIONS AND SET DELTA-L & DELTA-U
C
      CALL CRGION
C
C     USING THE SYMMETRY PROPERTY, FLIP THE INTERVALS
C
      CALL ACTOCI
C
C     SET THE VARIABLE TO BE RETURNED
C
      IF (LN1.GT.LN2) GOTO 40
      J1=1
      J2=2
      DO 210 K1=0,N1
         DO 220 K2=0,N2
             KK4=K1*(N2+1)+K2+1
             ZDELTA(KK4,1)=DELTA(KK4,1)
             ZDELTA(KK4,2)=DELTA(KK4,2)
             X(KK4,J1)=IDATA(KK4,2)
             X(KK4,J2)=IDATA(KK4,3)
 220     CONTINUE
 210  CONTINUE
      RETURN
 40   J1=2
      J2=1
      DO 110 K1=0,N1
         DO 120 K2=0,N2
             KK4=K1*(N2+1)+K2+1
             KK3=K2*(N1+1)+K1+1
             ZDELTA(KK3,2)=-DELTA(KK4,1)
             ZDELTA(KK3,1)=-DELTA(KK4,2)
             X(KK3,J1)=IDATA(KK4,2)
             X(KK3,J2)=IDATA(KK4,3)
 120     CONTINUE
 110  CONTINUE
      RETURN
      END
C
C
      SUBROUTINE SINIT
C
C     INITIALIZATION PROCEDURE
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
C     SET SIZE OF ARRAY FOR THE ACCEPTANCE REGION AT EACH DELTA
      IS1=500
C
C     SET SIZE OF ARRAY FOR B,C ...MAX(N1,N2) + 1
C
      ISBC1=31
C
C     SIZE OF ARRAY FOR THE PROBABILITY VECTOR AT EACH DELTA
C             CORRESPONDING THE MESH OF P1
C
      ISP1=1001
      IB=0
      IC=0
      RETURN
      END
C
C                             
      SUBROUTINE COMBIN       
C                             
C     SET COMBINATORIAL AND OTHER COEFFICIENTS                       
C                                                                     
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      ALPHA=1.-ALPHA                                                  
C                                                                     
C     NUMBER OF POINTS IN X1 * X2 SPACE                               
C                                                                     
      N12=(N1+1)*(N2+1)                                               
      NMAX=2*N12+2                                                    
C     CALCULATE N CHOOSE X                                            
      CALL COMB(CNX1,N1,ISBC1)                                        
      CALL COMB(CNX2,N2,ISBC1)                                        
      IDBYP=PARTD/PARTP                                               
      CALL CRPRO                                                      
      RETURN                                                          
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE CRZERO                                                
C                                                                      
C     CREATE THE ACCEPTANCE REGION FOR DELTA = 0                       
C          INITIAL STEP FOR THE INDUCTIONS    
C                         
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER IWKA1(4),IWKA2(4),IWKB(31)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      I=0                                                              
C                                                                      
C     SET THE IDATA...EACH EVENT X1 AND X2 AND ITS CODE                
C     SET THE EQUIVALENCE CLASS...ICLASS, AND ITS REPLICA              
C                                                                      
      DO 10 I1=0,N1                                                    
         DO 20 I2=0,N2                                                 
            I=I+1                                                      
            IDATA(I,1)=I                                               
            IDATA(I,2)=I1                                              
            IDATA(I,3)=I2                                              
            ICLASS(I)=N2*I1-N1*I2                                      
            DELTA(I,1)=0.                                              
            DELTA(I,2)=0.                                              
 20      CONTINUE                                                      
 10   CONTINUE                                                         
C                                                                      
C     FIND THE MIN VALUE OF EQUIVALENCE CLASS CORRESPONDING TO (0,N2)  
C                                                                      
      IYMIN=IFMIN(ICLASS,N12,IS1)                                      
      IYMWK=IYMIN
      DO 30 I=1,N12                                                    
         ICLASS(I)=ICLASS(I)+1-IYMIN                                   
         ICLS1(I)=ICLASS(I)                                            
 30   CONTINUE                                                         
C                                                                      
C     INITIAL STEP : FIND INITIAL ACCEPTANCE REGION 
C                                                                      
      IYMIN=IFMIN(ICLASS,N12,IS1)                                      
      IB=ISBC1                                                         
      CALL FINDB(N12,IYMIN,B,IB)                                       
      DO 40 I=1,N12                                                    
         AR(I)=I                                                       
 40   CONTINUE                                                         
C                                                                      
C     FIND THE CLASS C...TO BE ADDED TO AC                             
C                                                                      
      ID=0                                                             
C                                                                      
C     CALCULATE THE NUMBER OF P1 POSSIBLE IN PARTITION                      
C                                                                      
      IP1=1+PARTP                                                      
C                                                                      
C     SET THE NUMBER OF THE ELEMENTS IN THE ACCEPTANCE REGION          
C                                                                      
      IA=N12                                                           
C                                                                      
C     SET P(AR) = 1                                                    
C                                                                      
      DO 50 I=1,IP1                                                    
         PA(I)=1.                                                      
  50     CONTINUE                                                      
      DO 61 I=1,ISBC1                                                  
         IWKB(I)=0                                                     
  61     CONTINUE                                                      
         IC=0                                                          
C                                                                      
C      ELIMINATION STEP                                              
C                                                                      
            IWB=0                                                      
 110        DO 60 I=1,4                                                
               IWKA2(I)=0                                              
  60        CONTINUE                                                   
            EL=0                                                       
            DO 70 I=1,IP1                                              
C                                                                      
C      CALCULATE THE EXCESS AT EACH P1 ON THE LINE             
C                                                                      
               SP(I)=PA(I)-ALPHA                                       
 70         CONTINUE                                                   
C                                                                      
C      FIND THE MIN(SP-P(B(I))                                    
C                                                                      
            DO 80 I=1,IB                                               
               IWKA1(1)=B(I)                                           
               IX1=IDATA(B(I),2)                                       
               IX2=IDATA(B(I),3)                                       
               IWKA1(2)=(N2+1)*(N1-IX1)+N2-IX2+1                       
               IWKA1(3)=0                                              
               IWKA1(4)=0                                              
               IWA=2                                                   
               IF (N1.NE.N2) GOTO 91                                   
                  IRHO=(N2+1)*(N1-IX2)+N2-IX1+1                        
                  IF (IRHO.EQ.IWKA1(1)) GOTO 91                        
                     IWKA1(3)=IRHO                                     
                     IWKA1(4)=(N2+1)*IX2+IX1+1                         
                     IWA=4                                             
  91           CALL CRPA0(PB,ISP1,IWKA1,IS1,IWA,IP1,ID)                
C                                                                      
C      FIND THE MINIMUM OF THE EXCESS                          
C                                                                      
               DO 90 J=1,IP1                                           
                  PB(J)=SP(J)-PB(J)                                    
 90            CONTINUE                                                
C                                                                      
C      MIN                                                     
C                                                                      
               PBMIN=FMIN(PB,ISP1,IP1)                                 
C                                                                      
C      CHECK THIS B(I) GIVES THE MAX .                         
C                                                                      
               IF (PBMIN.LE.EL) GOTO 80                                
C                                                                      
C      THIS B(I) IS BEST POINT TO ELIMINATE THUS FAR           
C                                                                      
               DO 95 J=1,IP1                                           
                  PW(J)=SP(J)-PB(J)                                    
 95            CONTINUE                                                
               EL = PBMIN                                              
               DO 160 J=1,4                                            
                  IWKA2(J)=IWKA1(J)                                    
 160            CONTINUE                                               
 80         CONTINUE                                                   
C                                                                      
C      CHECK IF SOME X CAN BE ELIMINATED.                         
C                                                                      
            IF (IWKA2(1).EQ.0) GOTO 150                                
C                                                                      
C      THESE X(IWKA2) CAN BE ELIMIMATED.                          
C      UPDATE AR & B BY DELETING THIS B(I) FROM AR & B            
C                                                                      
            DO 100 I=1,4                                               
               IF (IWKA2(I).EQ.0) GOTO 100                             
                  CALL DELETE(AR,IWKA2(I),IS1,IA)                      
 100        CONTINUE                                                   
            DO 101 I=1,2                                               
               J=1+2*(I-1)                                             
               IF (IWKA2(J).EQ.0) GOTO 101                             
                  CALL DELETE(B,IWKA2(J),ISBC1,IB)                     
                  IWB=IWB+1                                            
                  IWKB(IWB)=IWKA2(J)                                   
 101        CONTINUE                                                   
C                                                                      
C      SET P(AR) = P(AR)-P(B(I))                                  
C                                                                      
 121        DO 120 J = 1 ,IP1                                          
               PA(J)=PA(J)-PW(J)                                       
 120        CONTINUE                                                   
C                                                                      
C      CHECK WHETHER B IS EMPTY                                   
C                                                                      
 125        IF (IB.NE.0) GOTO 110                                      
C                                                                      
C      CREATE NEW B SET TO BE ELIMINATED                          
C                                                                      
            IYMIN=IFMIN(ICLS1,N12,IS1)                                 
            IBWK=IYMIN+IYMWK-1
            IB=ISBC1                                                   
            CALL FINDB(N12,IYMIN,B,IB)                                 
            DO 126 I=1,ISBC1                                           
               IWKB(I)=0                                               
 126        CONTINUE                                                   
            IWB=0                                                      
C
C     CHECK WHETHER AR CONTAINS THE ENTIRE CLASS WHOSE
C          POINT ESTIMATION EQUALS ZERO.
C
            IF (IBWK.NE.0) GOTO 110
 150  CONTINUE                                                         
C                                                                      
C     SET ICLASS (THE EQUIV. CLASS WITH DELTA > MAX(DELTA IN AR) )     
C                                                                      
      IYMAX = 0                                                        
      DO 52 I=1,IA                                                     
         IF (ICLASS(AR(I)).LE.IYMAX) GOTO 52                           
            IYMAX=ICLASS(AR(I))                                        
  52  CONTINUE                                                         
      DO 54 I=1,N12                                                    
         IF (ICLASS(I).GT.IYMAX) GOTO 54                               
            ICLASS(I)=NMAX                                             
  54  CONTINUE                                                         
C                                                                      
C     CREATE C (THE SUBSET IN THE EQUIV. CLASS TO BE ADDED TO THE      
C       ACCEPTANCE REGION IN THE INDUCTIVE STEPS)                      
C                                                                      
      IF (IWB.EQ.0) GOTO 57                                            
         DO 56 I=1,IWB                                                 
            IX1=IDATA(IWKB(I),2)                                       
            IX2=IDATA(IWKB(I),3)                                       
            IRHO=(N2+1)*(N1-IX1)+N2-IX2+1                              
            C(I)=IRHO                                                  
  56  CONTINUE                                                         
  57  IC=IWB                                                           
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE CRGION                                                
C                                                                      
C     CREATE THE ACCEPTANCE REGION FOR EACH DELTA                      
C      AND SET THE DELTA_L & DELTA_U                                   
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
 100  DO 50 ID=1,PARTD                                                 
C                                                                      
C        SET DELTA                                                     
C                                                                      
         D=FLOAT(ID)/PARTD                                             
C                                                                      
C        CALCULATE THE NUMBER OF P1 POSSIBLE IN THE PARTITION          
C             DEFINED BY PARTD                                         
C                                                                      
         IP1=1+(PARTD-ID)/IDBYP                                        
C                                                                      
C     CALCULATE ALL THE POSSIBLE PROBABILITIES WITH P1,P2           
C     I.E. P1**X1 * Q1**N1-X1 & P2**X2 * Q2**N2-X2                  
C     CALCULATE P(AR) AT EACH P1 ON THE P1-P2=DELTA LINE            
C                                                                      
         CALL CRPA0(PA,ISP1,AR,IS1,IA,IP1,ID)                          
C                                                                      
C     SET MINIMUM OF P(AR) ON THE LINE                              
C                                                                      
         PAMIN=FMIN(PA,ISP1,IP1)                                       
C                                                                      
C     IF MIN(P(AR)) >= ALPHA, THEN GO TO THE ELIMINATION STEP       
C     ELSE GOTO THE ADDITION STEP LABELED 60.                       
C                                                                      
         IF (ALPHA.GT.PAMIN) GOTO 60                                   
C                                                                      
C     ELIMINATION STEP                                              
C                                                                      
 110        IBD=0                                                      
            IBD1=0                                                     
            EL=0                                                       
            DO 70 I=1,IP1                                              
C                                                                      
C     CALCULATE THE EXCESS AT EACH P1 ON THE LINE             
C                                                                      
               SP(I)=PA(I)-ALPHA                                       
 70         CONTINUE                                                   
C                                                                      
C     FIND THE MIN(SP-P(B(I))                                    
C                                                                      
            DO 80 I=1,IB                                               
C                                                                      
C     CALCULATE THE P(X) , X IN B                             
C                                                                      
               ISW=0                                                   
               CALL CRPA1(PB,ISP1,B(I),IP1,ID)                         
C                                                                      
C     FIND THE MINIMUM OF THE SURPLUS                         
C                                                                      
               DO 90 J=1,IP1                                           
                  PB(J)=SP(J)-PB(J)                                    
 90            CONTINUE                                                
C                                                                      
C     MIN                                                     
C                                                                      
               IF (N1.NE.N2) GOTO 91                                   
                  IX1=IDATA(B(I),2)                                    
                  IX2=IDATA(B(I),3)                                    
                  IRHO=(N2+1)*(N2-IX2)+N1-IX1+1                        
                  IF (IRHO.EQ.B(I)) GOTO 91                            
                     CALL CRPA1(PW1,ISP1,IRHO,IP1,ID)                  
                     DO 92 J=1,IP1                                     
                        PB(J)=PB(J)-PW1(J)                             
 92                  CONTINUE                                          
                     ISW=1                                             
 91            PBMIN=FMIN(PB,ISP1,IP1)                                 
C                                                                      
C     CHECK THIS B(I) GIVES THE MAX .                         
C                                                                      
               IF (PBMIN.LE.EL) GOTO 80                                
C                                                                      
C     THIS B(I) IS BEST POINT TO ELIMINATE THUS FAR           
C                                                                      
               DO 95 J=1,IP1                                           
                  PW(J)=SP(J)-PB(J)                                    
 95            CONTINUE                                                
               EL = PBMIN                                              
               IBD=B(I)                                                
               IF (ISW.EQ.1) IBD1=IRHO                                 
               IF (ISW.EQ.0) IBD1=0                                    
 80         CONTINUE                                                   
C                                                                      
C     CHECK IF SOME X CAN BE ELIMINATED.                         
C                                                                      
            IF (IBD.EQ.0) GOTO 50                                      
C                                                                      
C     IF DELTAHAT IS BIGGER THAN CURRENT DELTA THEN DO NOT DELETE      
C                                                                      
            WDELTA=IDATA(IBD,2)/FLOAT(N1) - IDATA(IBD,3)/FLOAT(N2)     
            IF (WDELTA.LE.D) GOTO 82                                   
            GOTO 50                                                    
 82         CONTINUE                                                   
C                                                                      
C     THIS X(=IBD) CAN BE ELIMIMATED.                            
C                                                                      
C     SO SET THE UPPER DELTA LIMIT CORRESPONDING TO THIS X.              
C                                                                      
            DELTA(IBD,2)=D                                             
C                                                                      
C     UPDATE AR & B BY DELETING THIS B(I) FROM AR & B            
C                                                                      
            CALL DELETE(AR,IBD,IS1,IA)                                 
            CALL DELETE(B,IBD,ISBC1,IB)                                
            IF (IBD1.EQ.0) GOTO 121                                    
               DELTA(IBD1,2)=D                                         
               CALL DELETE(AR,IBD1,IS1,IA)                             
               CALL DELETE(B,IBD1,ISBC1,IB)                            
C                                                                      
C     SET P(AR) = P(AR)-P(B(I))                                  
C                                                                      
 121        DO 120 J = 1 ,IP1                                          
               PA(J)=PA(J)-PW(J)                                       
 120        CONTINUE                                                   
C                                                                      
C     CHECK WHETHER B IS EMPTY                                   
C                                                                      
 125        IF (IB.NE.0) GOTO 110                                      
C                                                                      
C           CREATE NEW B SET TO BE ELIMINATED                          
C                                                                       
            IYMIN=IFMIN(ICLS1,N12,IS1)                                 
            IB=ISBC1                                                   
            CALL FINDB(N12,IYMIN,B,IB)                                 
            GOTO 110                                                   
C                                                                      
C     ADDITION STEP                                                 
C                                                                      
 60         CONTINUE                                                   
C                                                                      
C     CHECK IF C IS EMPTY                                        
C                                                                      
            IF (IC.NE.0) GOTO 130                                      
               IYMAX=IFMIN(ICLASS,N12,IS1)                             
               IC=ISBC1                                                
               CALL FINDC(N12,IYMAX,C,IC)                              
C                                                                      
C     FIND THE MAX(P(C(J)))                                      
C                                                                      
 130        ICD=0                                                      
            ICD1=0                                                     
            AD=-1                                                      
C                                                                      
C     CALCULATE THE DEFICIENCY AT EACH P1 ON THE LINE            
C                                                                      
            DO 140 I=1,IP1                                             
               SP(I)=PA(I)-ALPHA                                       
 140        CONTINUE                                                   
C                                                                      
C     CALCULATE P(C(I))                                          
C                                                                      
            DO 150 I=1,IC                                              
               ISW=0                                                   
               CALL CRPA1(PC,ISP1,C(I),IP1,ID)                         
               DO 160 J=1,IP1                                          
                  PC(J)=SP(J)+PC(J)                                    
 160           CONTINUE                                                
               IF (N1.NE.N2) GOTO 161                                  
                  IX1=IDATA(C(I),2)                                    
                  IX2=IDATA(C(I),3)                                    
                  IRHO=(N2+1)*(N2-IX2)+N1-IX1+1                        
                  IF (IRHO.EQ.C(I)) GOTO 161                           
                     CALL CRPA1(PW1,ISP1,IRHO,IP1,ID)                  
                     ISW=1                                             
                     DO 162 J=1,IP1                                    
                        PC(J)= PC(J) + PW1(J)                          
 162                 CONTINUE                                          
 161           PCMIN=FMIN(PC,ISP1,IP1)                                 
C                                                                      
C     CHECK WHETHER THIS C GIVE THE MAXIMUN                   
C                                                                      
               IF (PCMIN.LE.AD) GOTO 150                               
               DO 180 J=1,IP1                                          
                  PW(J)=PC(J)-SP(J)                                    
 180           CONTINUE                                                
               AD=PCMIN                                                
               ICD=C(I)                                                
               IF (ISW.EQ.1) ICD1=IRHO                                 
               IF (ISW.EQ.0) ICD1=0                                    
 150        CONTINUE                                                   
C                                                                      
C     UPDATE C BY DELETING C(I) FROM C                           
C                                                                      
            CALL DELETE(C,ICD,ISBC1,IC)                                
            IA=IA+1                                                    
            AR(IA)=ICD                                                 
            DELTA(ICD,1)=D                                             
            IF (ICD1.EQ.0) GOTO 191                                    
               CALL DELETE(C,ICD1,ISBC1,IC)                            
               IA=IA+1                                                 
               AR(IA)=ICD1                                             
               DELTA(ICD1,1)=D                                         
C                                                                      
C     IF P(AR) >= ALPHA, THEN GO TO ELIMINATION,                 
C            ELSE GO TO ADDITION                     
C     IF (AD.GE.0) GOTO 110                                     
C                                                                      
 191        CALL CRPA0(PA,ISP1,AR,IS1,IA,IP1,ID)                       
            PAMIN=FMIN(PA,ISP1,IP1)                                    
            IF(AD.GE.0)GOTO 125                                        
            GOTO 60                                                    
 50      CONTINUE                                                      
      DELTA(AR(1),2)=1.                                                
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE FINDB(L1,IY,BB,IB1)                                   
C                                                                      
C     FIND THE NEXT EQUIVALENCE SET B TO BE ELIMINATED                 
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER BB(IB1)                                                  
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      IB1=0                                                            
      DO 10 I=1,L1                                                     
         IF (ICLS1(I).NE.IY) GOTO 10                                   
         IB1=IB1+1                                                     
         BB(IB1)=I                                                     
         ICLS1(I)=NMAX                                                 
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE FINDC(L1,IY,BC,IBC)                                   
C                                                                      
C     FIND THE NEXT EQUIVALENCE CLASS C TO BE ADDED                    
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER BC(IBC)                                                  
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      IBC=0                                                            
      DO 10 I=1,L1                                                     
         IF (ICLASS(I).NE.IY) GOTO 10                                  
         IBC=IBC+1                                                     
         BC(IBC)=I                                                     
         ICLASS(I)=NMAX                                                
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE CRPRO                                                 
C                                                                      
C     CALCULATE P1**X1 * Q1**N1-X1 & P2**N2 * Q2**N2-Q2 FOR ALL
C        POSSIBLE (P1,P2) PAIRS ON THE P1-P2=D LINE                             
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      DO 10 I=1,PARTD+1                                                
         P1=FLOAT(I-1)/PARTD                                           
         P2=P1                                                         
         Q1=1-P1                                                       
         Q2=1-P2                                                       
         PX1(1,I)=1                                                    
         DO 20 J=1,N1                                                  
            PX1(J+1,I)=P1**J                                           
 20      CONTINUE                                                      
         DO 30 J=1,N1                                                  
            PX1(J,I)=PX1(J,I)*Q1**(N1+1-J)                             
 30      CONTINUE                                                      
         PX2(1,I)=1                                                    
         DO 40 J=1,N2                                                  
            PX2(J+1,I)=P2**J                                           
 40      CONTINUE                                                      
         DO 50 J=1,N2                                                  
            PX2(J,I)=PX2(J,I)*Q2**(N2+1-J)                             
 50      CONTINUE                                                      
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE CRPA0(P,ISP,AA,ISA,IAA,IP,IDD)                        
C                                                                      
C     CALCULATE P(AR)                                                  
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(ISP)                                                 
      INTEGER AA(ISA)                                                  
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      DO 10 I=1,IP                                                     
         P(I)=0                                                        
 10   CONTINUE                                                         
      DO 20 J=1,IAA                                                    
         CALL CRPA1(PW1,ISP,AA(J),IP,IDD)                              
         DO 30 I=1,IP                                                  
            P(I)=P(I)+PW1(I)                                           
 30      CONTINUE                                                      
 20   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE CRPA1(P,ISP,BC,IP,IDD)                                
C                                                                      
C     CALCULATE P(X)                                                   
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(ISP)                                                 
      INTEGER BC                                                       
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      IX1=IDATA(BC,2)+1                                                
      IX2=IDATA(BC,3)+1                                                
      X=CNX1(IX1)*CNX2(IX2)                                            
      DO 10 I = 1,IP                                                   
         I2=1+(I-1)*IDBYP                                              
         I1=I2+IDD                                                     
         P(I)=X*PX1(IX1,I1)*PX2(IX2,I2)                                
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      FUNCTION FMIN(P,ISP,IP)                                          
C                                                                      
C     FIND THE MINIMUM OF THE REAL STRING P                            
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION P(ISP)                                                 
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      FMIN=1                                                           
      DO 10 I=1,IP                                                     
         FMIN=MIN(FMIN,P(I))                                           
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      FUNCTION IFMIN(IX,LIX,LSIX)                                      
C                                                                      
C     FIND THE MINIMUM OF THE INTEGER STRING IX                         
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER IX(LSIX)                                                 
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      IFMIN=NMAX                                                       
      DO 10 I=1,LIX                                                    
         IFMIN = MIN(IFMIN,IX(I))                                      
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE COMB(CNX,N,IS)                                        
C                                                                      
C     CALCULATE  N CHOOSE X ... N!/X!N-X!                              
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION CNX(IS)                                                
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      CNX(1)=1                                                         
      CNX(N+1)=1                                                       
      K=(N+1)/2                                                        
      DO 10 I=1,K                                                      
         CNX(I+1)=CNX(I)*(N+1-I)/FLOAT(I)                              
         CNX(N+1-I)=CNX(I+1)                                           
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE DELETE(A,IBD,L,LC)                                    
C                                                                      
C     DELETE IBD FROM A                                                
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INTEGER A(L)                                                     
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      LW=0                                                             
      DO 10 I=1,LC                                                     
         IF (A(I).EQ.IBD) GOTO 10                                      
         LW=LW+1                                                       
         A(LW)=A(I)                                                    
 10   CONTINUE                                                         
      LC=LW                                                            
      A(LC+1)=0                                                        
      RETURN                                                           
      END                                                              
C                                                                      
C                                                                      
      SUBROUTINE ACTOCI                                                
C                                                                      
C     FIND UPPER AND LOWER DELTA LIMITS USING THE SYMMETRY PROPERTY     
C                                                                      
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      INCLUDE 'DELTA.H1'
      INCLUDE 'DELTA.H2'
      DO 10 I=1,N12                                                    
         IF (DELTA(I,1).NE.0.) GOTO 20                                 
            DELTA(I,1)=-DELTA(N12+1-I,2)                               
 20      IF (DELTA(I,2).NE.0.) GOTO 10                                 
            DELTA(I,2)=-DELTA(N12+1-I,1)                               
 10   CONTINUE                                                         
      RETURN                                                           
      END                                                              
